-module(eWSrv).

-include("wsCom.hrl").

-export([
   startWSrv/3
   , stopWSrv/1
]).

startWSrv(WSrvName, Port, WsOpts) ->
   ListenName = wsUtil:lsName(WSrvName),
   TWsOpts = lists:keystore(conMod, 1, WsOpts, {conMod, wsHttp}),
   LWsOpts = lists:keystore(conArgs, 1, TWsOpts, {conArgs, WSrvName}),
   WsMod = ?wsGLV(wsMod, WsOpts, wsEgHer),
   case ?wsGLV(sslOpts, WsOpts, false) of
      false ->
         {ok, _} = eNet:openTcp(ListenName, Port, LWsOpts);
      _ ->
         {ok, _} = eNet:openSsl(ListenName, Port, LWsOpts)
   end,

   ConSupSpec = #{
      id => WSrvName,
      start => {wsConSup, start_link, [WSrvName, WsMod]},
      restart => permanent,
      shutdown => infinity,
      type => supervisor,
      modules => [wsConSup]
   },
   supervisor:start_child(eWSrv_sup, ConSupSpec).

stopWSrv(WSrvName) ->
   ListenName = wsUtil:lsName(WSrvName),
   eNet:close(ListenName),
   supervisor:terminate_child(eWSrv_sup, WSrvName),
   supervisor:delete_child(eWSrv_sup, WSrvName).