-module(wsConSup).

-behaviour(supervisor).

-export([
   start_link/2
]).

-export([
   init/1
]).

-spec(start_link(SupName :: atom(), WsMod :: module()) -> {ok, pid()}).
start_link(SupName, WsMod) ->
   supervisor:start_link({local, SupName}, ?MODULE, WsMod).

init(WsMod) ->
   SupFlags = #{strategy => simple_one_for_one, intensity => 100, period => 3600},

   WsHttpSpec = #{
      id => wsHttp,
      start => {wsHttp, start_link, [WsMod]},
      restart => transient,
      shutdown => 3000,
      type => worker,
      modules => [wsHttp]
   },
   {ok, {SupFlags, [WsHttpSpec]}}.
